routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/home', 'HomeController@index')->name('home');
//Route::get('/',function(){
//    return redirect()->to('/home');
//});
Route::get('new-password', 'Api\Client\AuthController@newPassword');
Route::post('password', 'Api\Client\AuthController@password');
Route::get('/logout', 'Auth\LoginController@logout');
// admin routes
Route::group(['prefix'=> 'admin','middleware'=>'auth'],function(){
    //user reset password
    Route::get('user/change-password','UserController@changePassword');
    Route::post('user/change-password','UserController@changePasswordSave');
    Route::resource('user','UserController');
    //Settings Routes
    Route::get('setting','SettingController@view');
    Route::post('setting','SettingController@update');
    Route::resource('contacts','ContactController',['only' => ['index','destroy','show']]);
    Route::resource('slider', 'SliderController');
        Route::resource('category', 'CategoryController');
    Route::resource('photo', 'PhotoController');
    Route::resource('book','BookController');
    Route::resource('client','ClientController');
    Route::resource('entry','EntryController');
    Route::get('book/{id}/approve', 'BookController@approve');
    Route::get('book/{id}/un-approve', 'BookController@unApprove');
    Route::get('client/{id}/approve', 'ClientController@approve');
    Route::get('client/{id}/un-approve', 'ClientController@unApprove');
});

Route::group(['middleware'=>'language'], function(){
    //Language Controller 
    Route::get('lang/{lang}', 'LanguageController@switchLang');

Route::get('/','FrontController@index');
Route::post('client_login','FrontController@postLogin')->name('client_login');
Route::post('client_register','FrontController@postRegister');
Route::post('client/logout','FrontController@logout');
Route::get('client/entries','FrontController@entries')->name('client.entries');

Route::group(['prefix'=> 'client','middleware'=>'auth:client'],function() {
    Route::get('books','FrontController@books');
    Route::get('book/{id}','FrontController@book');
    Route::get('add_entry/{id}','FrontController@getEntry');
    Route::get('edit_draft/{id}','FrontController@getDraft');
    Route::post('add_entry','FrontController@addEntry');
    Route::get('suggest_book','FrontController@getSuggestBook');
    Route::post('suggest_book','FrontController@suggestBook');
    Route::get('old_work','FrontController@oldWork');
    Route::get('my_entry','FrontController@myEntry');

});
});

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Book extends Model 
{

    protected $table = 'books';
    public $timestamps = true;
    protected $fillable = array('en_name','ar_name', 'en_description','ar_description', 'thumbnail','state','author','file','category_id');

    public function client()
    {
        return $this->belongsTo('App\Models\Client');
    }

    public function entries()
    {
        return $this->hasMany('App\Models\Entry');
    }

    public function rates()
    {
        return $this->hasMany('App\Models\Rate');
    }

    public function category()
    {
        return $this->belongsTo('App\Models\Category');
    }

    public static function boot()
    {
        parent::boot();
        self::deleting(function($model){
            if(file_exists($model->thumbnail))
                unlink($model->thumbnail);
        });
    }
}

app/Http/Controllers/BookController.php
<?php

namespace App\Http\Controllers;

use App\Models\Book;
use App\Models\Entry;
use Illuminate\Http\Request;
use Response;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        $books = Book::where(function($q) use($request){
            if($request->name)
            {
                $q->where('name','LIKE','%'.$request->en_name.'%');
                $q->orwhere('name','LIKE','%'.$request->ar_name.'%');

            }
            if($request->state)
            {
                $q->where('state',$request->state);
            }
            if(auth()->user()->hasRole('judge'))
            {
            	$q->where('state','approved');
            }
            })->latest()->paginate(20);
        return view('admin.books.index',compact('books'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Book $model)
    {
        return view('admin.books.create',compact('model'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'en_name'             => 'required',
            'ar_name'             => 'required',
            'thumbnail'         => 'required|mimes:jpeg,jpg,png',
            'file'              => 'required|mimes:doc,pdf,docx,zip',
            'category_id'       => 'required',
        ]);
        $request->merge(['state'=>'approved']);
        $book = Book::create($request->except('thumbnail','file'));
        if($request->hasFile('thumbnail'))
        {
            $image = $request->file('thumbnail');
            $destinationPath = public_path().'/uploads/books';
            $extension = $image->getClientOriginalExtension(); // getting image extension
            $name = time().''.rand(11111,99999).'.'.$extension; // renameing image
            $image->move($destinationPath, $name); // uploading file to given
            $book->update(['thumbnail' => 'uploads/books/'.$name]);
        }
        if($request->hasFile('file'))
        {
            $file = $request->file('file');
            $filedestinationPath = public_path().'/uploads/books/files';
            $extension = $file->getClientOriginalExtension(); // getting image extension
            $name = time().''.rand(11111,99999).'.'.$extension; // renameing image
            $file->move($filedestinationPath, $name); // uploading file to given
            $book->update(['file' => 'uploads/books/files/'.$name]);
        }
        flash()->success(' Book has been added successfully');
        return redirect('admin/book');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $book = Book::with('client')->findorfail($id);

        $entries = Entry::PublishedEntries()->with('client','book')->where('book_id',$book->id)->get();
        return view('admin.books.show',compact('book','entries'));
    }


    public function edit($id)
    {
        $model = Book::findOrFail($id);
        return view('admin.books.edit',compact('model'));
    }

    public function update(Request $request , $id)
    {

        $this->validate($request, [
            'en_name'             => 'required',
            'ar_name'             => 'required',
            'thumbnail'         => 'mimes:jpeg,jpg,png',
            'file'              => 'mimes:doc,pdf,docx,zip',
                        'category_id'       => 'required',

        ]);
        $book = Book::findOrFail($id);
        $book->update($request->except('thumbnail','file'));
         if ($request->hasFile('thumbnail'))
        {
            if (file_exists($book->thumbnail))
            {
                unlink($book->thumbnail); //unlink old image
            }
            $image = $request->file('thumbnail');
            $destinationPath = public_path().'/uploads/books';
            $extension = $image->getClientOriginalExtension(); // getting image extension
            $name = time().''.rand(11111,99999).'.'.$extension; // renameing image
            $image->move($destinationPath, $name); // uploading file to given
            $book->update(['thumbnail' => 'uploads/books/'.$name]);
        }

        if ($request->file)
        {
            if (file_exists($book->file))
            {
                unlink($book->file); 
            }
            $file = $request->file('file');
            $filedestinationPath = public_path().'/uploads/books/files';
            $extension = $file->getClientOriginalExtension(); 
            $name = time().''.rand(11111,99999).'.'.$extension; 
            $file->move($filedestinationPath, $name); 
            $book->update(['file' => 'uploads/books/files/'.$name]);
        }
        flash()->success('Book has been updated successfully');
        return redirect('admin/book/'.$id.'/edit');

    }

    public function destroy($id)
    {
        $book = Book::findOrFail($id);
        if(count($book->entries)>0)
    {
        $data = [
            'status' => 0,
            'msg' => 'Book cannot be deleted , it has entries',
            'id' => $id
        ];
        return Response::json($data, 200);
    }
        $book->delete();
        $data = [
            'status' => 1,
            'msg' => 'Book has been deleted successfully',
            'id' => $id
        ];
        return Response::json($data, 200);
    }


    public function approve($id)
    {
        $record = Book::findOrFail($id);
        $record->state = 'approved';
        $record->save();
        flash()->success(' book has been approved');
        return back();
    }

    public function unApprove($id)
    {
        $record = Book::findOrFail($id);
        $record->state = 'pending';
        $record->save();
        flash()->success(' Book approved has been canceled ');
        return back();
    }
}

resources/views/admin/books/create.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => ' Books',
                                'page_description'  => '  New Book'
                                ])
@section('content')
        <!-- general form elements -->
<div class="box box-primary">
    <!-- form start -->
    {!! Form::model($model,[
                            'action'=>'BookController@store',
                            'id'=>'myForm',
                            'role'=>'form',
                            'method'=>'POST',
                            'files'=>true
                            ])!!}

    <div class="box-body">

        @include('admin.books.form')

        <div class="box-footer">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>

    </div>
    {!! Form::close()!!}

</div><!-- /.box -->

@endsection

resources/views/admin/books/edit.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => ' books',
                                'page_description'  => ' Edit Book'
                                ])
@section('content')
        <!-- general form elements -->
<div class="box box-primary">
    <!-- form start -->
    {!! Form::model($model,[
                            'action'=>['BookController@update',$model->id],
                            'id'=>'myForm',
                            'role'=>'form',
                            'method'=>'PUT',
                            'files'=>true
                            ])!!}

    <div class="box-body">

        @include('admin.books.form')

        <div class="box-footer">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>

    </div>
    {!! Form::close()!!}

</div><!-- /.box -->

@endsection

resources/views/admin/books/form.blade.php
@include('admin.layouts.partials.validation-errors')
@include('flash::message')
@inject('category','App\Models\Category')

{!! \App\Ibnfarouk\MyClasses\Field::text('en_name','English Name ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::text('ar_name','Arabic Name ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::text('author',' Author Name ') !!}

  {!! \App\Ibnfarouk\MyClasses\Field::select('category_id',' choose category',$category->pluck('en_name','id')->toArray()) !!}

{!! \App\Ibnfarouk\MyClasses\Field::fileWithPreview('thumbnail','Thumbnail ') !!}
@if($model->thumbnail)
    <div class="col-md-4">
        <img src="{{url($model->thumbnail)}}" alt="" class="img-responsive thumbnail">
    </div>
@endif
<div class="clearfix"></div>
{!! \App\Ibnfarouk\MyClasses\Field::fileWithPreview('file','File ') !!}
@if($model->file)
        <a href="{{url($model->file)}}"  class="btn btn-info " target="_blank"><i class="fa fa-book"></i> view File </a>
@endif

<div class="clearfix"></div>
{!! \App\Ibnfarouk\MyClasses\Field::textarea('en_description','English description ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::textarea('ar_description','Arabic description ') !!}

resources/views/admin/books/index.blade.php
@extends('admin.layouts.main',[
								'page_header'		=> 'books',
								'page_description'	=> 'show books'
								])
@section('content')
    <div class="box box-primary">
        <div class="box-header">
                                    @if(auth()->user()->hasRole('admin'))
            <div class="pull-left">
                <a href="{{url('admin/book/create')}}" class="btn btn-primary">
                    <i class="fa fa-plus"></i>New Book
                </a>
            </div>
            @endif
            <div class="clearfix"> </div>
            <div class="row">
            {!! Form::open([
                'method' => 'GET'
            ]) !!}
            <div class="col-md-3">
                <div class="form-group">
                    <label for="">&nbsp;</label>
                    {!! Form::text('name',\Request::input('name'),[
                        'class' => 'form-control',
                        'placeholder' => 'book name '
                    ]) !!}
                </div>
            </div>
            <div class="col-md-3">
                <div class="form-group">
                    <label for="">&nbsp;</label>
                    {!! Form::select('state',['approved'=>'approved' ,'pending'=>'pending'],\Request::input('state'),
                    [    'class' => 'form-control',
                        'placeholder' => 'state'
                    ]) !!}
                </div>
            </div>
                <div class="col-md-2">
                    <div class="form-group">
                        <label for="">&nbsp;</label>
                        <button class="btn btn-flat btn-block btn-primary">search</button>
                    </div>
                </div>
                {!! Form::close() !!}
            </div>
        </div>
        <div class="box-body">
            @include('flash::message')
        @if(!empty($books) && count($books)>0)
        <div class="table-responsive">
            <table class="table table-bordered">
                <thead>
                <th>#</th>
                <th> English Name</th>
                <th> Arabic Name</th>
                <th>  Category </th>
                @if(auth()->user()->hasRole('admin'))
                    <th class="text-center">approved /pending</th>
                    @endif
                <th> thumbnail </th>
                <th class="text-center">Info</th>
                @if(auth()->user()->hasRole('admin'))
                    <th class="text-center">Edit</th>
                <th class="text-center">Delete</th>
                    @endif
                </thead>
                <tbody>
                    @php $count = 1; @endphp
                    @foreach($books as $book)
                        <tr id="removable{{$book->id}}">
                            <td>{{$count}}</td>
                            <td> {{$book->en_name}}</td>
                            <td> {{$book->ar_name}}</td>
                            <td> {{$book->category->en_name ?? '-'}}</td>
                        @if(auth()->user()->hasRole('admin'))
                            <td class="text-center">
                                @if($book->state == 'approved')
                                    <a href="book/{{$book->id}}/un-approve" class="btn btn-xs btn-danger"><i class="fa fa-close"></i> Un approve</a>
                                @else
                                    <a href="book/{{$book->id}}/approve" class="btn btn-xs btn-success"><i class="fa fa-check"></i> Approve</a>
                                @endif
                            </td>
                            @endif
                            <td class="text-center">
                                <a href="{{asset($book->thumbnail)}}" data-lightbox="image-1" data-title="{{$book->name}}">
                                    <img src="{{asset($book->thumbnail)}}" alt="" style="height: 70px;"></a> </td>
                            <td class="text-center"><a href="{{url('admin/book/'.$book->id)}}" class="btn btn-xs btn-info"><i class="fa fa-info"></i></a></td>
                            @if(auth()->user()->hasRole('admin'))
                            <td class="text-center"><a href="{{url('admin/book/'.$book->id. '/edit')}}" class="btn btn-xs btn-success"><i class="fa fa-edit"></i></a></td>
                             <td class="text-center">
                                <button id="{{$book->id}}" data-token="{{ csrf_token() }}" data-route="{{URL::route('book.destroy',$book->id)}}"  type="button" class="destroy btn btn-danger btn-xs"><i class="fa fa-trash-o"></i></button>
                            </td>
                                @endif
                        </tr>
                        @php $count ++; @endphp
                    @endforeach
                </tbody>
            </table>
        </div>
            {!! $books->render() !!}
        @else
                <div>
                    <h3 class="text-info" style="text-align: center">No Data To Show </h3>
                </div>
            @endif
    </div>
</div>
@stop

resources/views/admin/books/show.blade.php
@extends('admin.layouts.main',[
								'page_header'		=> 'books',
								'page_description'	=> 'book  details'
								])
@section('content')
    <div class="box box-primary">
        <div class="box-body">
            @include('flash::message')
            <div class="table-responsive">
                <table class="data-table table table-bordered">
                    <tbody>
                    <tr>
                        <td>English book Name </td>
                        <td>{{$book->en_name}}</td>
                    </tr>
                    <tr>
                        <td>Arabic book Name </td>
                        <td>{{$book->ar_name}}</td>
                    </tr>
                    <tr>
                        <td> book author</td>
                        <td>{{$book->author ?? '-'}}</td>
                    </tr>
                     <tr>
                        <td> book Category</td>
                                                <td> {{$book->category->en_name ?? '-'}}</td>
                    </tr>

                    <tr>
                        <td> Client Name</td>
                        @if(count($book->client))
                        <td>{{$book->client->name ?? '-'}}</td>
                        @else
                        <td> added by admin </td>
                        @endif
                    </tr>
                    <tr>
                        <td> English book description</td>
                        <td>{!! $book->en_description !!}</td>
                    </tr>
                    <tr>
                        <td> Arabic book description</td>
                        <td>{!! $book->ar_description !!}</td>
                    </tr>
                    @if(auth()->user()->hasRole('admin'))
                        <tr>
                        <td>  book state</td>
                        <td>
                            @if($book->state == 'approved')
                                <a href="{{url('admin/book/'. $book->id.'/un-approve')}}" class="btn btn-xs btn-danger"><i class="fa fa-close"></i> Pending</a>
                            @else
                                <a href="{{url('admin/book/'.$book->id.'/approve')}}" class="btn btn-xs btn-success"><i class="fa fa-check"></i> Approved</a>
                            @endif
                        </td>
                    </tr>
                        @endif
                    <tr>
                        <td>   Book Cover </td>
                        <td class="text-center">
                            <a href="{{asset($book->thumbnail)}}" data-lightbox="image-1" data-title="{{$book->name}}">
                                <img src="{{asset($book->thumbnail)}}" alt="" style="height: 70px;"></a> </td>

                    </tr>
                    </tbody>
                </table>
            </div>
            <div class="clearfix"></div>
            @if(count($book->entries)>0)
                <h3>Entries</h3>
                <div class="box box-primary">
                    <div class="box-body">
                        <div class="table-responsive">
                            <table class="data-table table table-bordered">
                                <thead>
                                <th>#</th>
                                <th>  client name</th>
                                <th>  summary </th>
                                @if(auth()->user()->hasRole('judge'))
                                    <th class="text-center">Rate</th>
                                    @endif
                                    @if(auth()->user()->hasRole('admin'))
                                    <th class="text-center">Delete</th>
                                    @endif
                                <th class="text-center">More</th>
                                </thead>
                                <tbody>
                                @foreach($entries as $item)
                                    <tr id="removable{{$item->id}}">
                                        <td>{{$loop->iteration}}</td>
                                        <td>{{optional($item->client)->name ?? 'no name !!'}} {{$item->client->l_name}}</td>
                                        <td>{{$item->summary}}</td>
                                        @if(auth()->user()->hasRole('judge'))
                                        <td class="text-center">
                                            <a href="{{url('admin/entry/'.$item->id .'/edit')}}" class="btn btn-xs btn-success"><i
                                                        class="fa fa-edit"></i></a>
                                        </td>
                                       
                                        @endif
                                        <td class="text-center">
                                <button id="{{$item->id}}" data-token="{{ csrf_token() }}" data-route="{{URL::route('entry.destroy',$item->id)}}"   type="button" class="destroy btn btn-danger btn-xs"><i class="fa fa-trash-o"></i></button>
                            </td>
                                        <td class="text-center">
                                            <a href="{{url('admin/entry/'.$item->id )}}" class="btn btn-xs btn-info"><i
                                                        class="fa fa-info-circle"></i></a>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                        <div class="text-center">
                        </div>

                        <div class="clearfix"></div>
                    </div>
                </div>
            @endif
        </div>
    </div>
@stop